#!/usr/bin/env python3
#!/nlp/projekty/metatrans2/public_html/python3/bin/python3

import os
import sys

from symbols import Symbol
from rule import Rule
from ijacek import TopDownChartParser


def test_rule():
    EPSILON = '(X) → ε'
    epsilon = Rule(EPSILON)
    if str(epsilon) != EPSILON:
        raise AssertionError(str(epsilon), EPSILON)


# interleaved (proložený, ve správném pořadí!) stdout a stderr, ne za sebou?!
# jednoduše můžu výstup duplikovat a prostě ignorovat stdout
if __name__ == '__main__':
    test_rule()

    top_down = TopDownChartParser(argv=sys.argv)

    tokens = [
        Symbol(tag='k2gInSc1', word='krásný'),
        Symbol(tag='k2gInSc1', word='košatý'),
        Symbol(tag='k1', word='strom', g='I', n='S', c='1'),
        Symbol(word=','),
        Symbol(k='7', word='na'),
        Symbol(tag='k3', lemma='který', g='I', n='S'),
        Symbol(tag='k6', word='silně'),
        Symbol(tag='k5', word='foukalo', e='A', a='I', m='A', g='N', n='S'),
        Symbol(tag='k3', word='se'),
        Symbol(tag='k5eNaPmAgInS', word='nevyvrátil'),
    ]
    top_down.parse(tokens)

    tokens = [
        # ?košatý krásný strom (hodnoticí slovo by mělo být před upřesňujícím)
        Symbol(tag='k2', word='krásný', g='I', n='S', c='4'),
        Symbol(tag='k2', word='košatý', g='I', n='S', c='4'),
        Symbol(tag='k1', word='strom', g='I', n='S', c='1'),
    ]
    top_down.parse(tokens, 'NP')

    tokens = (
        'Líbí	líbit	k5eAaImIp3nS',
        'se	sebe	k3xPyFc4',
        'mi	já	k3xPp1nSc3',
        'to	ten	k3xDgNnSc1',
        ',	,	kIx,',
        'co	co	k3yQnSc4',  # cos?
        'jsi	být	k5eAaImIp2nS',
        'napsal	napsat	k5eAaPmAgMnS',
        # '.	.	kIx.',
    )
    top_down.parse_from_vertical(tokens)

    tokens = [
        'strom	strom	k1gInSc1',
        'života	život	k1gInSc2',
    ]
    top_down.parse_from_vertical(tokens, root='NP')
    # 0–2 (NP g=I n=S c=1) → (NP g=I n=S c=1) (NP g=I n=S c=2) •

    tokens = (
        Symbol('(word=Zkouším lemma=zkoušet k=5 e=A n=S p=1 a=I m=I)'),
        Symbol('(word=parser lemma=parser k=1 g=I n=S c=1)'),
        Symbol('(word=! lemma=! k=I x=.)'),
    )
    top_down.parse(tokens)


# TODO: automaticky rozpoznat, že jsme na (barevné) konzoli a zapnout pager
def pipepager(text, cmd='less'):
    """Page through text by feeding it to another program."""
    pipe = os.popen(cmd, 'w')
    try:
        pipe.write(text)
        pipe.close()
    except IOError:
        pass  # Ignore broken pipes caused by quitting the pager program.
